/// <amd-module name="@dataform/sqlx/lexer" />
export declare enum SyntaxTreeNodeType {
    JAVASCRIPT = 0,
    JAVASCRIPT_TEMPLATE_STRING_PLACEHOLDER = 1,
    SQL = 2,
    SQL_COMMENT = 3,
    SQL_LITERAL_STRING = 4,
    SQL_STATEMENT_SEPARATOR = 5
}
export declare class SyntaxTreeNode {
    readonly type: SyntaxTreeNodeType;
    private allChildren;
    static create(code: string): SyntaxTreeNode;
    static isSyntaxTreeNode(node: string | SyntaxTreeNode): node is SyntaxTreeNode;
    constructor(type: SyntaxTreeNodeType, allChildren?: Array<string | SyntaxTreeNode>);
    children(): (string | SyntaxTreeNode)[];
    concatenate(): string;
    push(child: string | SyntaxTreeNode): this;
    equals(other: SyntaxTreeNode): boolean;
}
